<template>
  <div class="inputPhone">
    <div
      class="input"
      :class="{
        'inputComposite': composite,
        '-invalid': validation.hasError('value') || classes['-invalid'],
        '-not-empty': !!value }
      ">
      <AppSelect
        :value="selected"
        :options="countries"
        :searchable="false"
        :disabled="disabled"
        :classes="['multiselect__flag', 'no-checkbox']"
        track-by="id"
        placeholder=""
        @select="onSelectCountry">
        <template
          slot="singleLabel"
          slot-scope="{ option }">
          <div class="selected-flag-item">
            <img
              class="flag"
              :alt="option.title"
              :src="'/frontapp/flags/' + option.id + '.svg'">
            <span class="country-code">
              {{ `+ ${option.countryCode}` }}
            </span>
          </div>
        </template>
        <template
          slot="option"
          slot-scope="{ option }">
          <div class="item">
            <img
              class="flag"
              :alt="option.title"
              :src="'/frontapp/flags/' + option.id + '.svg'">
            <span class="country-code">
              {{ `+ ${option.countryCode}` }}
            </span>
          </div>
        </template>
      </AppSelect>
      <masked-input
        type="tel"
        ref="input"
        class="input-field"
        :value="phoneWithoutCode"
        :placeholder="selected.placeholder || 'Номер телефона'"
        :disabled="disabled"
        :mask="mask"
        :show-mask="true"
        :guide="guide"
        @input="onChangePhoneNumber"
        placeholder-char="_"/>
      <span
        v-if="composite"
        class="inputComposite-label">
        Ваш телефон
        <sup
          v-if="isRequired"
          class="__red"> *</sup>
      </span>
    </div>
    <div
      class="input-message-error _left"
      :class="{'_top': classes['validate-top']}"
      v-if="validation.hasError('value')">
      {{ validation.firstError('value') }}
    </div>
  </div>
</template>

<script>
import SimpleVueValidation from 'simple-vue-validator';
import AppSelect from '~/components/redesign/app-select/app-select';
import Validator from '~/assets/js/validator';
import MaskedInput from 'vue-text-mask';
import { find, get } from 'lodash-es';

const SimpleVueValidator = SimpleVueValidation.Validator;

export default {
  name: 'AppInputPhone',
  components: {
    'masked-input': MaskedInput,
    AppSelect,
  },
  props: {
    classes: {
      type: Object,
      default() { return {}; },
    },
    value: {
      type: String,
      default: '',
    },
    phone: {
      type: Object,
      default() { return {}; },
    },
    options: {
      type: Object,
      default() { return {}; },
    },
    fluid: {
      type: Boolean,
      default: false,
    },
    flagDisabled: {
      type: Boolean,
      default: false,
    },
    hasValidate: {
      type: Boolean,
      default: false,
    },
    onlyMobile: {
      type: Boolean,
      default: false,
    },
    disabled: {
      type: Boolean,
      default: false,
    },
    validateError: {
      type: String,
      default: '',
    },
    composite: {
      type: Boolean,
      default: true,
    },
  },
  data() {
    return {
      countries: [
        {
          id: 390,
          countryCode: '7 ',
          mask: [/\d/, /\d/, /\d/, ' ', /\d/, /\d/, /\d/, '-', /\d/, /\d/, '-', /\d/, /\d/],
          placeholder: '___ ___-__-__',
          regexp: /7 \d{3} \d{3}-\d{2}-\d{2}/,
          title: 'Россия',
        },
        {
          id: 1964,
          countryCode: '380 ',
          mask: [/\d/, /\d/, ' ', /\d/, /\d/, /\d/, '-', /\d/, /\d/, '-', /\d/, /\d/],
          placeholder: '__ ___-__-__',
          regexp: /380 \d{2} \d{3}-\d{2}-\d{2}/,
          title: 'Украина',
        },
        {
          id: 1,
          countryCode: '7 7',
          mask: [/\d/, /\d/, ' ', /\d/, /\d/, /\d/, '-', /\d/, /\d/, '-', /\d/, /\d/],
          placeholder: '__ ___-__-__',
          regexp: /7 7\d{2} \d{3}-\d{2}-\d{2}/,
          title: 'Казахстан',
        },
        {
          id: 260,
          countryCode: '375 ',
          mask: [/\d/, /\d/, '-', /\d/, /\d/, /\d/, '-', /\d/, /\d/, '-', /\d/, /\d/],
          placeholder: '__-___-__-__',
          regexp: /375 \d{2}-\d{3}-\d{2}-\d{2}/,
          title: 'Белоруссия',
        },
        {
          id: 1959,
          countryCode: '86 ',
          mask: [/\d/, /\d/, /\d/, /\d/, /\d/, /\d/, /\d/, /\d/, /\d/, /\d/, /\d/, /\d/, /\d/, /\d/],
          placeholder: '__________',
          regexp: /86 \d{10,14}/,
          title: 'Китай',
        },
        {
          id: 1994,
          countryCode: '90 ',
          mask: [/\d/, /\d/, /\d/, /\d/, /\d/, /\d/, /\d/, /\d/, /\d/, /\d/],
          placeholder: '__________',
          regexp: /90 \d{10}/,
          title: 'Турция',
        },
      ],
      selected: null,
    };
  },
  computed: {
    mask() {
      if (this.selected) {
        return this.selected.mask;
      }
      return this.countries[0].mask;
    },
    allowRequestUniquePhoneNumber() {
      return this.options
        && this.options.validationRule
        && this.options.validationRule.isUnique
        && !this.phone.isDuplicate
        && this.phone;
    },
    isRequired() {
      if (this.options.validationRule) {
        return false;
      }
      return true;
    },
    phoneWithoutCode() {
      const fullNumber = this.value;
      if (typeof fullNumber === 'string') {
        return (fullNumber
          .replace(/\+|\(|\)/g, '')
          .replace(this.selected.countryCode, ''));
      }
      return this.value;
    },
    guide() {
      return this.selected.id !== 1959 || (
        this.value
        && this.value.split('_')[0].length < 13
      );
    },
  },
  validators: {
    value(value) {
      return SimpleVueValidator
        .value(value)
        .custom(async () => {
          this.phone.isSet = false;
          if (!value) {
            if (!get(this.options, 'validationRule.isRequired', false)) {
              this.phone.isValid = true;
              this.$emit('has-error', false);
              return false;
            }
            this.phone.isValid = false;
            this.$emit('has-error', true);
            return 'Укажите телефон';
          }

          if (!Validator.checkPhone(value) || !this.selected.regexp.test(value)) {
            this.phone.isValid = false;
            this.$emit('has-error', true);
            return 'Укажите корректный телефон';
          }

          if (this.phone.isDuplicate) {
            this.$emit('has-error', true);
            return 'Номер телефона уже используется';
          }

          if (this.allowRequestUniquePhoneNumber) {
            return this.$axios
              .$get('/_main/user/checkUniquePhone', {
                params: {
                  phone: this.value && this.value.replace(/[^\d]/gi, ''),
                  additionalInformationRequest: this.options.additionalInformationRequest,
                },
              })
              .then(({ data }) => {
                if (!data) {
                  this.phone.isValid = false;
                  this.phone.isSet = true;
                  return 'Номер телефон уже используется';
                }
                this.phone.isValid = true;
                return false;
              })
              .catch(e => console.error(e));
          }

          this.phone.isValid = true;
          this.$emit('has-error', false);
          return false;
        });
    },
  },
  watch: {
    mask(newValue, oldValue) {
      if (newValue !== oldValue) {
        if (process.client) {
          localStorage.setItem('phoneInputDefault', newValue);
          if (this.$refs.input && this.$refs.input.$el) this.$refs.input.$el.focus();
        }
      }
    },
    value(newValue) {
      if (newValue && !(this.flagDisabled || this.onlyMobile)) {
        this.countries.forEach((country) => {
          if (country.regexp.test(newValue)) {
            this.selected = country;
          }
        });
      }
    },
    hasValidate() {
      this.$validate();
    },
  },
  created() {
    this.selected = this.countries[0];

    if (this.flagDisabled || this.onlyMobile) {
      if (this.flagDisabled) {
        this.selected = this.countries[0];
      }

      if (this.onlyMobile) {
        this.selected = {
          mask: [9, /\d/, /\d/, ' ', /\d/, /\d/, /\d/, '-', /\d/, /\d/, '-', /\d/, /\d/],
        };
      }
    } else {
      this.countries.forEach((country) => {
        if (country.regexp.test(this.value)) {
          this.selected = country;
        }
      });
    }
  },
  methods: {
    onSelectCountry(country) {
      if (country) {
        this.$set(this, 'selected', find(this.countries, { id: country.id }));
        this.$emit('input', '');
      }
    },
    onChangePhoneNumber(value) {
      // TODO: Во всех вхождениях этого компонента. Заменить строку номера телефона на объект Phone
      const withCode = this.selected.countryCode + value;

      if (this.phone.model) {
        const phone = Object.assign({}, this.phone, {
          isMobile: Validator.isMobilePhoneNumber(withCode),
          hasChange: this.validation.isTouched('value'),
        });

        phone.model.phone = withCode;
        this.$emit('input', phone);
      } else {
        this.$emit('input', withCode);
      }
    },
  },
};
</script>

<style lang="postcss">
@import "~/assets/css/components/forms/input-composite.css";

.inputPhone {
  width: 100%;
  position: relative;

  .input {
    display: flex;
    flex-direction: row;
    justify-content: center;
    align-items: center;
    width: 100%;

    &-field {
      border-left: none;
      border-top-left-radius: 0;
      border-bottom-left-radius: 0;

      &::-webkit-input-placeholder {
        color: var(--placeholder-color);
      }

      &::-moz-placeholder {
        color: var(--placeholder-color);
      }
    }

    .inputComposite-label {
      left: 5.8rem;
    }

    &.inputComposite {
      .input-field {
        &::-webkit-input-placeholder {
          color: var(--bg-main);
        }

        &::-moz-placeholder {
          color: var(--bg-main);
        }
      }
    }

    &.-not-empty .input-field,
    .input-field:focus {

      &::-webkit-input-placeholder {
        color: var(--placeholder-color);
      }

      &::-moz-placeholder {
        color: var(--placeholder-color);
      }
    }
  }

  .inputComposite {
    .multiselect__flag {
      height: 3.5rem;
    }
  }

  .multiselect__flag {
    min-width: 5.8rem;
    width: 5.8rem;

    .selected-flag-item, .item {
      width: 100%;
      display: flex;
      align-items: center;

      .flag {
        display: flex;
        align-items: center;
        flex-shrink: 0;
        width: 1.5rem;
        height: auto;
        border-radius: .125rem;
        overflow: hidden;
      }

      .country-code {
        margin-left: .5rem;
      }
    }

    .multiselect {
      &__clear,
      &__select {
        display: none;
      }

      &__single {
        width: 100%;
        justify-content: center;
      }

      &__tags {
        padding-right: 0.5rem;
        padding-left: 0.5rem;
        border-top-right-radius: 0;
        border-bottom-right-radius: 0;
        background-color: var(--bg-main);

        &:after {
          content: none;
        }
      }

      &__option {
        padding: .5rem;
      }

      &__element {
        .item {
          display: flex;
          align-items: center;
          width: 100%;

          .country-code {
            margin-left: .5rem;
          }
        }
      }
    }
  }

  .input-message-error._top {
    position: absolute;
    top: -1.188rem;
    left: 0;
  }
}
</style>
